include:
  - project: "cicd-tool/ci-templates"
    ref: master
    file:
      - .gitlab-ci.v1.0.yml

variables:
  GIT_SUBMODULE_STRATEGY: recursive
  IMAGE_REPOSITORY: docker.io/nhatns/golang-application
  NO_SCAN_FILES: '.env|.envrc|[a-zA-Z0-9_-]+_test.go|go.sum'
  DOCKER_BUILD_OPTS: --build-arg GITLAB_TOKEN=${CI_JOB_TOKEN}

# Template Pre Stage
.prestage: &prestage
  stage: pretest
  only:
    refs:
      - merge_requests
      - master
  except:
    - pipelines

go-vet:
  <<: *prestage
  variables:
    GOSUMDB: "off"
  before_script:
    - echo "before script go vet"
  script:
    - echo "go vet"

code_navigation:
  image: sourcegraph/lsif-go:v1.2
  stage: pretest
  allow_failure: true # recommended
  before_script:
    - git config --global http.sslVerify false
  script:
    - lsif-go
  artifacts:
    reports:
      lsif: dump.lsif